%define __distdep %(/bin/rpm -qf /etc/redhat-release | %{__sed} 's/-[^-]*$//' | %{_bindir}/head -1)
%define __distpkg %(echo %{__distdep} | %{__sed} 's/-[^-]*$//')
%define __distvers %(echo %{__distdep} | %{__sed} 's/.*-//' | %{_bindir}/tr -d '[:alpha:]')
%define __distinit %(%{__sed} -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' /etc/redhat-release | %{_bindir}/tr -d '[:space:]' | %{_bindir}/cut -c 1-4 | %{_bindir}/tr '[:upper:]' '[:lower:]')
%define __perl_version %(eval "`%{__perl} -V:version`"; echo $version)
%define __perl_package Mail-SPF-Query

Summary:	%{__perl_package} module for perl 
Name:		perl-%{__perl_package}
Version:	1.997
Release:	4.%{__distinit}%{__distvers}
License:	Artistic
Group:		Applications/CPAN
Source0:	%{__perl_package}-%{version}.tar.gz
Patch0:		MSQ-fallback.patch
Url:		http://spf.pobox.com/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:	noarch
BuildRequires:	perl-Net-CIDR-Lite >= 0.15, perl-Net-DNS >= 0.46, perl-Sys-Hostname-Long >= 1.0
Requires:	%{__distpkg} >= %{__distvers}, perl >= %{__perl_version}
Requires:	perl-Net-CIDR-Lite >= 0.15, perl-Net-DNS >= 0.46, perl-Sys-Hostname-Long >= 1.0
Prereq:		/usr/sbin/alternatives
Provides:	spf

%description
The SPF protocol relies on sender domains to publish a DNS
whitelist of their designated outbound mailers.  Given an
envelope sender, Mail::SPF::Query determines the legitimacy
of an SMTP client IP.

%prep
%setup -q -n %{__perl_package}-%{version}
%patch0 -p1

%build
CFLAGS="$RPM_OPT_FLAGS" %{__perl} Makefile.PL PREFIX=$RPM_BUILD_ROOT%{_prefix} INSTALLDIRS=vendor
%{__make}

%check
%{__make} test

%clean
[ "$RPM_BUILD_ROOT" != "/" -a -n "$RPM_BUILD_ROOT" ] && %{__rm} -rf $RPM_BUILD_ROOT

%install
[ "$RPM_BUILD_ROOT" != "/" -a -n "$RPM_BUILD_ROOT" ] && %{__rm} -rf $RPM_BUILD_ROOT
%makeinstall
%{__mv} $RPM_BUILD_ROOT%{_bindir}/spfquery $RPM_BUILD_ROOT%{_bindir}/spfquery.Mail::SPF::Query
%{__mv} $RPM_BUILD_ROOT%{_bindir}/spfd     $RPM_BUILD_ROOT%{_bindir}/spfd.Mail::SPF::Query

[ -x /usr/lib/rpm/brp-compress ] && /usr/lib/rpm/brp-compress
%{_bindir}/find $RPM_BUILD_ROOT \( -name perllocal.pod -o -name .packlist \) -exec %{__rm} -v {} \;
%{_bindir}/find $RPM_BUILD_ROOT%{_prefix} -type f -print | \
    %{__sed} "s@^$RPM_BUILD_ROOT@@g" > %{__perl_package}-%{version}-filelist
if [ "$(%{__cat} %{__perl_package}-%{version}-filelist)X" = "X" ] ; then
    echo "ERROR: EMPTY FILE LIST"
    exit -1
fi

%post
%{_sbindir}/alternatives --install %{_bindir}/spfquery spf %{_bindir}/spfquery.Mail::SPF::Query 50 \
	--slave %{_bindir}/spfd spf-daemon %{_bindir}/spfd.Mail::SPF::Query
exit 0

%preun
if [ $1 = 0 ]; then
	%{_sbindir}/alternatives --remove spf %{_bindir}/spfquery.Mail::SPF::Query
fi
exit 0

%postun
if [ "$1" -ge "1" ]; then
	spf=`%{_bindir}/readlink /etc/alternatives/spf`
	if [ "$spf" == "%{_bindir}/spfquery.Mail::SPF::Query" ]; then
		%{_sbindir}/alternatives --set spf %{_bindir}/spfquery.Mail::SPF::Query
        fi
fi
exit 0

%triggerpostun -- perl-Mail-SPF-Query < 1.997-3
%{_sbindir}/alternatives --auto spf

%files -f %{__perl_package}-%{version}-filelist
%defattr(-,root,root)
%doc README* MANIFEST Changes sample

%changelog
* Mon Aug  2 2004 Paul Howarth <paul@city-fan.org> 1.997-4
- Include sample directory as %%doc, suggested by
  Chuck Mead <csm@moongroup.com>
- Move `make test' to %%check section
- Use macros to specify locations of `alternatives' and `readlink'

* Tue Jul 27 2004 Paul Howarth <paul@city-fan.org> 1.997-3
- Even more macros.
- Use `alternatives' so that the spfquery and spfd programs can co-exist
  with versions from other implementations.

* Tue Jun 29 2004 Paul Howarth <paul@city-fan.org> 1.997-2
- Incorporate patch from David Lawless <lawless@spamcop.net> to ensure
  that fallback records are checked if there is a non-SPF TXT record
  present for the domain being checked.

* Mon Apr 26 2004 Paul Howarth <paul@city-fan.org> 1.997-1
- Update to 1.997.
- Resolver timeout patch now incorporated upstream, so removed
  from package.

* Tue Apr 20 2004 Paul Howarth <paul@city-fan.org> 1.996-4
- Added patch by Joe Christy <joe@eshu.net> to shorten resolver
  timeout periods.

* Wed Apr 14 2004 Paul Howarth <paul@city-fan.org> 1.996-3
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuilt from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Sat Feb 28 2004 Paul Howarth <paul@city-fan.org> 1.996-2
- Removed perl-LMAP-CID2SPF dependency; this is checked at runtime

* Fri Feb 27 2004 Paul Howarth <paul@city-fan.org> 1.996-1
- Update to 1.996

* Fri Feb 27 2004 Paul Howarth <paul@city-fan.org> 1.995-2
- Increased perl-Net-DNS dependency to version 0.46 in line with Makefile.PL

* Fri Feb 27 2004 Paul Howarth <paul@city-fan.org> 1.995-1
- Update to 1.995

* Thu Feb 26 2004 Paul Howarth <paul@city-fan.org> 1.993-1
- Update to 1.993
- Added dependencies on perl-LMAP-CID2SPF and perl-Sys-Hostname-Long

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 1.991-3
- Removed bogus dependencies for Sendmail::Milter

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 1.991-2
- Unified spec file for Red Hat and Fedora Core

* Thu Jan 29 2004 Paul Howarth <paul@city-fan.org> 1.991-1.fc1
- Update to 1.991

* Mon Jan 26 2004 Paul Howarth <paul@city-fan.org> 1.99-1.fc1
- Update to 1.99

* Fri Jan 09 2004 Paul Howarth <paul@city-fan.org> 1.96-1.fc1
- Initial build
